function k = qmflattice(h);
% h ? impulse-response coefficients of a minimum-phase FIR filter 
% k ? lattice coefficients
% Author: Jelena Certic
hnorm = h/h(1);
k(length(hnorm)-1) = -hnorm(length(hnorm));
for n = length(hnorm)-3:-2:1
    gnorm = fliplr(hnorm);
    gnorm(1:2:length(gnorm)) = -gnorm(1:2:length(gnorm));
    hnorm = (hnorm+k(n+2)*gnorm)/(1+k(n+2)^2);
    hnorm = hnorm(1:n+1);
    k(n) = -hnorm(n+1);
end;
